{$R+}
Program h;
{W tekste na qp. qz. zamenqem po tablice slova i ieroglify;
  po srawn. s prog. dlq kit. qz. razresheny bolee dlinn. slowa.
}

{PLEASE NOTE: this program needs TMT Pascal of FPC Pascal to run,
  otherwise one should decrease the sizes of arrays of hieroglyphs
  and words !!!
}

 const nier_max=3000; nslov_max=2500;
 const lslov=14; lopis=38; lbuf={20}14;
 {dliny w bajtah: slowo - maks. 7 2-bajt. el-ta, bufer - tozhe;
   neobh. lbuf>=lslov, dostat. =lslov .
 }
 type iero=record ie:array[1..2] of char; opis:string[lopis]; end;
 var ier:array[1..nier_max] of iero; nier:integer;
 type slovo=record sl:string[lslov]; opis:string[lopis]; ispolxz:integer; end;
 var slova:array[1..nslov_max] of slovo; nslov:integer;
 var buf:string[lbuf];
 var otlad:boolean;
 var b:file of byte; bb:text; c1,c2:byte; i,k:integer; byl_0A,fict:boolean;
 var ii,ii1000,ispolxz_total,ispolxz_total0,dispolxz_total:longint;

 procedure vv_ier_slo;
 {zhelat. sdel. proverku, chto posle slova net probelov}
  var f:text; s:string; i:integer;
 begin
  writeln('Wwod ier.:');
  assign(f,paramstr(1)); reset(f);
  repeat readln(f,s); until s='^$^';
  nier:=0; for i:=1 to nier_max do if not eof(f) then begin
   nier:=nier+1;
   with ier[nier] do begin
    readln(f,ie[1],ie[2]); readln(f,s);
    {if copy(s,length(s)-5,6)='$0D$0A' then s:=copy(s,1,length(s)-6);}
    opis:=s;
    if (nier mod 1000)=1 then writeln(nier);
   end;
  end;
  if not eof(f) then writeln('Nado narastitx nier_max !!!');
  close(f);
  writeln('----- nier=',nier);
  writeln('Wwod slow:');
  assign(f,paramstr(2)); reset(f);
  repeat readln(f,s); until s='^$^';
  nslov:=0; for i:=1 to nslov_max do if not eof(f) then begin
   nslov:=nslov+1;
   with slova[nslov] do begin
    readln(f,sl);
    if length(sl)=0 then begin writeln('Osh.: pust.stroka.'); halt; end;
    readln(f,s);
    if copy(s,length(s)-5,6)='$0D$0A' then s:=copy(s,1,length(s)-6);
    opis:=s; {writeln(nslov:5,' ',opis);}
    ispolxz:=0;
    if (nslov mod 1000)=1 then writeln(nslov);
   end;
  end;
  if not eof(f) then writeln('Nado narastitx nslov_max !!!');
  close(f);
  writeln('----- nslov=',nslov);
  ispolxz_total:=0;
 end;

 function poisk(c1,c2:byte):integer; var j:integer; najd:boolean;
 begin
  j:=0; repeat
   j:=j+1; with ier[j] do najd:=(chr(c1)=ie[1]) and (chr(c2)=ie[2]);
  until najd or (j=nier);
  if not najd then j:=0;
  poisk:=j;
 end;

 procedure sbros_1; var c1,c2:byte; j:integer;
 {sbros odnogo ieroglifa}
 begin
  if buf='' then exit;
  c1:=ord(buf[1]); c2:=ord(buf[2]); buf:=copy(buf,3,length(buf)-2);
  j:=poisk(c1,c2);
  if j=0 then begin
   writeln(bb,chr(c1),chr(c2)); byl_0A:=true;
  end else begin
   if not byl_0A then writeln(bb);
   write(bb,'----- ');
   if otlad then write(bb,'    ',chr(c1),chr(c2),'   ');
   writeln(bb,ier[j].opis);
   byl_0A:=true;
  end;
 end;

 function sbros_slovo:boolean; var i,len,k:integer; gef:boolean;
 {sbros odnogo slowa;
   chtoby prog. bystree rabotala, zhelat. chasto wstrech. slowa
   razmeshch. w nachale slowarq;
   chtoby w parah tipa shita/shitagatte, kagaku/kagakusha
   uznawala bolee dlinn. slowa, w sloware ih nado pomeshch. wperedi.
 }
 begin
  if buf='' then begin sbros_slovo:=false; exit; end;
  {writeln(bb,'sbros_slovo poluch. upr.; buf=/',buf,'/');}
  i:=0; repeat inc(i);
   len:=length(slova[i].sl); gef:=slova[i].sl=copy(buf,1,len);
  until gef or (i=nslov);
  if gef then begin
   if not byl_0A then writeln(bb);
   write(bb,'-+++- ');
   for k:=1 to 8-len do write(bb,' '); write(bb,slova[i].sl); write(bb,' ');
   writeln(bb,slova[i].opis);
   byl_0A:=true;
   buf:=copy(buf,length(slova[i].sl)+1,lslov);
   inc(slova[i].ispolxz); inc(ispolxz_total);
  end;
  {writeln(bb,'sbros_slovo: vozvr., buf=/',buf,'/ ',gef,' ',i); writeln(bb);}
  sbros_slovo:=gef;
 end;

 procedure sbros_all; label ende;
 begin
  {writeln(bb,'sbros_all \ /',buf,'/');}
  if buf='' then goto ende;
  while sbros_slovo do; if buf='' then goto ende;
  while buf<>'' do begin sbros_1; while sbros_slovo do; end;
  ende:
  {writeln(bb,'sbros_all / /',buf,'/');}
 end;

 procedure add_1(c1,c2:byte); var g:boolean;
 begin
  {writeln(bb,'add_1 poluch. upr.; c1,c2=',c1,' ',c2);}
  if length(buf)=lbuf then g:=sbros_slovo;
  if length(buf)=lbuf {sbrosit` slowo ne udalos`} then sbros_1;
  buf:=buf+chr(c1)+chr(c2);
  {writeln(bb,'add_1: vozvr.');}
 end;

 procedure indikaciq;
 begin
  if ii>ii1000*1000 then begin
   dispolxz_total:=ispolxz_total-ispolxz_total0;
   writeln(ii:7,' ',ispolxz_total:7,' ',dispolxz_total:4);
   inc(ii1000); ispolxz_total0:=ispolxz_total;
  end;
 end;

Begin
 if (paramcount<>4) then begin
  writeln('Obr.: progr fajl_ier fajl_slov infile outfile .'); halt;
 end;
 otlad:=true;
 {--------}
 filemode:=0;
 vv_ier_slo;
 assign(b,paramstr(3)); reset(b);
 assign(bb,paramstr(4)); rewrite(bb);
 ii:=0; ii1000:=0; ispolxz_total0:=0; buf:=''; while not eof(b) do begin
  while not (eof(b) or (length(buf)=lbuf)) do begin
   read(b,c1); inc(ii); {writeln(ii:5,' ',chr(c1));} indikaciq;
   if c1<$80 then begin
    if buf<>'' then sbros_all; write(bb,chr(c1));
    if c1=$0A then byl_0A:=true else byl_0A:=false;
   end else begin
    read(b,c2); inc(ii); add_1(c1,c2);
   end {c1<$80};
  end {eof or length(buf)=lbuf};
  fict:=sbros_slovo; if not fict then sbros_1;
 end {eof};
 if buf<>'' then sbros_all;
 close(bb); close(b);
 {--------}
 if otlad then begin
  writeln('Zapis` protokola...');
  assign(bb,'protokol.txt'); rewrite(bb);
  for i:=1 to nslov do with slova[i] do begin
   write(bb,i:4,' ');
   if length(sl)<=8 then begin
    for k:=length(sl)+1 to 8 do write(bb,' '); write(bb,sl);
   end else begin
    write(bb,copy(sl,1,6),'..');
   end;
   writeln(bb,' ',opis:lopis,' ',ispolxz:5);
  end;
  close(bb);
 end;
End.
